package soduko;

public class SudokuSolverMini {
	static final int[][] sets = new int[27][9];
	static {
		for (int i = 0; i < 9; i++) {
			for (int j = 0; j < 9; j++) {
				sets[i][j] = 9*i + j;
				sets[9+i][j] = 9*j + i;
				sets[18+3*(i/3)+j/3][3*(i%3) + (j%3)] = 9*i + j;
			}
		}
	}
	private static boolean guess(short[] sudoku) {
		int ind = -1;
		OUT: for (int bc = 2; bc <= 9; bc++) {
			for (ind = 0; ind < sudoku.length; ind++) {
				if (Util.bitCount(sudoku[ind]) == bc) break OUT;
			}
		}
		if (ind == sudoku.length) return false;
		short[] bak = (short[]) sudoku.clone();
		for (int i = 0; i < 9; i++) {
			if (((sudoku[ind] >> i) & 1) != 0) {
				sudoku[ind] = (short) (1 << i);
				if (solve(sudoku)) return true;
				System.arraycopy(bak, 0, sudoku, 0, sudoku.length);
			}
		}
		return false;
	}
	private static boolean reduce(short[] sudoku, int comb, int[] set) {
		boolean mod = false;
		int bits = 0;
		for (int i = 0; comb >> i != 0; i++) {
			if (((comb >> i) & 1) != 0) bits |= sudoku[set[i]];
		}
		if (Util.bitCount(bits) == Util.bitCount(comb)) {
			for (int i = 0; i < set.length; i++) {
				if (((comb >> i) & 1) == 0) {
					if ((sudoku[set[i]] & bits) != 0) mod = true;
					sudoku[set[i]] &= ~bits;
				}
			}
		}
		return mod;
	}
	private static boolean test(short[] sudoku) {
		for (int i = 0; i < sudoku.length; i++) { 
			if (Util.bitCount(sudoku[i]) != 1) return false;
		}
		return true;
	}
	public static boolean solve(short[] sudoku) {
		boolean mod;
		
		do {
			mod = false;
			for (int s = 0; s < sets.length; s++) {
				for (int c = 1; c < 0x1ff; c++) {
					if (reduce(sudoku, c, sets[s])) mod = true;
				}
			}
		} while (mod);
		return test(sudoku)? true : guess(sudoku);
	}
}
